#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <stddef.h>
#include <wchar.h>
#include <locale.h>

#define VERSION "V2.0"
#define PROG "ascii2ams"
#define e1 0xE9 // le e accent aigue sur codage fr_FR.UTF8
#define e2 0xE8 // le e accent grave en codage fr_FR.UTF8
#define a 0xE0 // a accent codage fr_FR.UTF8
#define eof '\032' 
#define eol "\r\n"
//char eof='\032';
//char eol[2] ="\r\n";

void usage()
{
	fprintf(stderr,"Author:sid@cpcscene.com Version: %s\n",VERSION);
	fprintf(stderr,"Convert Unix ascii file in Amsdos ascii file : \n\
USAGE: %s <Option> <UNIX FILE> <OUTPUT(optionnal)>\n\n",PROG);
	fprintf(stderr,"Option : \n\t -a convert unix ascii to amsdos\n\
\t -u convert amsdos ascii to unix\n\n");
	exit(0);
}
void nix2ams(char* in,FILE* out)
{
	char buff[1024];
	FILE* file;
	wint_t i;
	long int ln=0,lf=1;
	if ((file=fopen(in,"r"))==NULL) 
	{ perror("FILE ERROR\n"); exit(0);}
	
	while (!feof(file))
	{
		lf=ln;
    i=fgetwc(file);
		ln=ftell(file);
		if (ln==lf) { break; }
    if ( (i!= e1 && i!=e2 && i!=a ) &&  i > 0x7f) fprintf(out,"?"); // cas d'un code ascii etendue
    else 
    { 
      switch(i)
      {
      case '\n': fprintf(out,"%s",eol); break;
      case e1 : fprintf(out,"%c",'{'); break;
      case e2 : fprintf(out,"%c",'}'); break;
      case a : fprintf(out,"%c",'@'); break;
      default : fprintf(out,"%c",i); break; 
     }
   }
	}
  fprintf(out,"%s",eol);
	fprintf(out,"%c",eof);
	fclose(file);
}	
void ams2nix(char* in,FILE* out)
{
	char buff[1024];
	FILE* file;
	int i;
	long int ln=0,lf=1;
	if ((file=fopen(in,"r"))==NULL) 
	{ perror("FILE ERROR\n"); exit(0);}
	
	while (!feof(file))
	{
  		lf=ln;
		fgets(buff,1024,file);
		ln=ftell(file);
  	if (ln==lf) break;
		for (i=0;i<strlen(buff)+1;i++)
		{
      switch (buff[i])
      {
       case '\r' : fprintf(out,"\n"); break;
       case '\n' : break;
       case '\032' : break ;
       case  '\0' : break ;
      default : fprintf(out,"%c",buff[i]); break ; 
      }
		}
	}
	fclose(file);
}	
int main (int argc,char **argv)
{
	char *in;
	char *output;
	FILE * out;
  
	if (argc < 3 | argc > 4) usage();
  if ( strcmp(setlocale(LC_ALL,"fr_FR.UTF-8"),"fr_FR.UTF-8") != 0 )
  {
     perror("LC_ALL ERROR \n"); 
  }
	if ( (in=(char*)malloc(strlen(argv[2])+1*sizeof(char))) == NULL)
	{ perror("MEMORY ERROR\n"); exit(0); }
	strcpy(in,argv[2]);

	if (argc == 4) 
	{
		if ( (output=(char*)malloc(strlen(argv[2])+1*sizeof(char))) == NULL)
		{ perror("MEMORY ERROR\n"); exit(0); }
		strcpy(output,argv[3]);
		if ((out=fopen(output,"w"))==NULL)
		{ perror("FILE ERROR\n"); exit(0);}
		if (strcmp(argv[1],"-u")) nix2ams(in,out);
		else if (strcmp(argv[1],"-a")) ams2nix(in,out);
		else { fprintf(stderr,"BAD OPTIONS\n"); fclose(out); exit(0); }
		fclose(out);
	}
	else if (strcmp(argv[1],"-u")) nix2ams(in,stdout);
	else if (strcmp(argv[1],"-a")) ams2nix(in,stdout);
	else { fprintf(stderr,"BAD OPTIONS\n");  exit(0); }
	
	
return 1;
}

